Subject: Re: linux-next: add utrace tree

From: Ingo Molnar <[email-masked]>
Date: Wed, 20 Jan 2010 07:28:34 +0100

* Ananth N Mavinakayanahalli <[email-masked]> wrote:

> On Wed, Jan 20, 2010 at 06:49:50AM +0100, Ingo Molnar wrote:
> 
> Ingo,
> 
> > Note, i'm not yet convinced that this (and the rest: uprobes and systemtap, 
> > etc.) can go uptream in its present form.
> 
> Agreed, uprobes is still not upstream ready -- it was an RFC. We are
> working through the comments there to get it ready for merger.
> 
> > IMHO the far more important thing to address beyond formalities and workflow 
> > cleanliness are the (many) technical observations and objections offered by 
> > Peter Zijstra on lkml. Not just the git history but also the abstractions and 
> > concepts are messy and should be reworked IMO, and also good and working perf 
> > events integration should be achieved, etc.
> 
> I think Oleg addressed most of Peter's concerns on utrace when the 
> ptrace/utrace patchset was reposted.

Peter is Cc:-ed and he might want to chime in.

> Perf integration with uprobes will be done and discussions have started with 
> Masami and Frederic. There are a couple of fundamental technical aspects 
> (XOL vma vs. emulation; breakpoint insertion through CoW and not through 
> quiesce) that need resolution.
> 
> > The fact that there's a well established upstream workflow for instrumentation 
> > patches, which is being routed around by the utrace/uprobes/systemtap code 
> > here is not a good sign in terms of reaching a good upstream solution. Lets 
> > hope it works out well though.
> 
> Agreed.
> 
> On the other hand, having ptrace/utrace in the -next tree will give it a
> lot more testing, while any outstanding technical issues are being addressed.

Including experimental code that is RFC and which is not certain to go 
upstream is certainly not the purpose of linux-next though.

It will cause conflicts with various other trees and increases the overhead 
all around. It also causes us to trust linux-next bugreports less - as it's 
not the 'next Linux' anymore. Also, there's virtually no high-level technical 
review done in linux-next: the trees are implicitly trusted (because they are 
pushed by maintainers), bugs and conflicts are reported but otherwise it's a 
neutral tree that includes pretty much any commit indiscriminately.

If you need review and testing there's a number of trees you can get inclusion 
into.

	Ingo